package il.ac.tau.cs.software1.my_music.ui;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;

/**
 * A login dialog that opens, receives the user id and login and the name of the
 * file in which the user should be saved
 */
public class CreateUserDialog extends MyMusicDialog {

	private Text nameField; // user name field
	private Text idField; // user id field
	private Text fileField; // data file field

	public CreateUserDialog(Shell parent) {
		super(parent, "Create new user");
	}

	/**
	 * Creates a new dialog (but does not open it yet. To open the dialog call
	 * open().)
	 * 
	 * @param parent
	 *            - the window from which this dialog was opened
	 */
	@Override
	protected void createForm() {
		// the form itself
		Composite form = new Composite(dialogShell, SWT.BORDER);
		form.setLayout(new GridLayout(3, false));

		// User name field
		nameField = createFieldWithLabel(form, "User name:", 2);

		// User ID field
		idField = createFieldWithLabel(form, "User ID:", 2);

		// Field for the file to associate the user with
		fileField = createFieldWithLabel(form, "Data file:", 1);
		Button browseButton = new Button(form, SWT.PUSH);
		browseButton.setText("Browse...");
		browseButton.addSelectionListener(new SelectionAdapter() {
			// TODO complete (hint: use
			// il.ac.tau.cs.software1.my_music.ui.GUIUtils.getFile)
		});

		// ok and Cancel buttons
		Composite buttonGroup = createOKAndCancel(form);
		GridData buttonData = new GridData();
		buttonData.horizontalSpan = 3;
		buttonGroup.setLayoutData(buttonData);
	}

	/**
	 * Creates the listener to be activated when the "ok" button is pressed.
	 * Verifies the validity of the field values, and if they are valid a new
	 * user is created, a welcome message is displayed and the dialog is closed
	 * (hint: use org.eclipse.swt.widgets.Shell.dispose()). Otherwise, an error
	 * message is displayed.
	 */
	@Override
	protected SelectionAdapter getOkSelectionListener() {
		// TODO complete
	}

	/**
	 * 
	 */
	@Override
	protected void setActionFailed() {
		// TODO complete
	}
}
